#%RAML 1.0
version: v1
title: Cache Function API
description: Cache functions for bin & state

types:
  genericResponse: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/api-response-datatype-api/1.0.0/api-response-datatype-api.raml
  getBinResponseValid: !include Datatype/getBinResponseValid.raml
  getStateResponseValid : !include Datatype/getStateResponseValid.raml
  saveStateRequest: !include Datatype/saveStateRequest.raml
  updateStateRequest: !include Datatype/updateStateRequest.raml

traits:
  headerTrait: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/header-securable/1.0.0/header-securable.raml

/cachebin/{MSISDN}:
  uriParameters:
    MSISDN:
        type: string
        description: Mobile Number key to be used for the cache
        example: "bridge-639178273617"
  get:
    is:
      - headerTrait
    description: Get BIN using the mobile number of the subscriber
    headers:
      correlationid:
        type: string
        description: Correlation ID being passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
      
    responses:
      200:
        body:
          application/json:
            type: !include Datatype/getBinResponseValid.raml
            example: !include Examples/BIN Example/getBin/getBinSuccessfulResponseExample.json
      400:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError400Example.json
      404:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError404Example.json 
      405:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError405Example.json
      406:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError406Example.json
      415:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError415Example.json
      500:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError500Example.json
      501:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/getBin/getBinResponseError501Example.json
              
/cachebin/{MSISDN}/{BIN}:
  uriParameters:
    MSISDN:
      description: Mobile Number key of the subscriber
      example: "bridge-639178217423"
    BIN:
      description: Brand ID of the Mobile Number
      example: "1"
  
  post:
    is:
      - headerTrait
    description: Save BIN of the subscriber in the cache
    headers:
      correlationid:
        type: string
        description: Correlation ID being passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    responses:
      200:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinSuccessfulResponseExample.json
      400:
        body:
          application/json:
            example: !include Examples/BIN Example/saveBin/saveBinResponseError400Example.json
      404:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError404Example.json 
      405:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError405Example.json
      406:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError406Example.json
      415:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError415Example.json
      500:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError500Example.json
      501:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/BIN Example/saveBin/saveBinResponseError501Example.json
             
/cachestate/{MSISDN}:
  uriParameters:
    MSISDN:
        type: string
        description: Mobile Number key to be used for the cache
        example: "spectre-freefb-639178273617"
  get:
    is:
      - headerTrait
    description: Get state of the subscriber in the cache
    headers:
      correlationid:
        type: string
        description: Correlation ID being passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"

    responses:
      200:
        body:
          application/json:
            type: getStateResponseValid
            example: !include Examples/State Example/getState/getStateSuccessfulResponse.json
      400:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError400Example.json
      404:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError404Example.json 
      405:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError405Example.json
      406:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError406Example.json
      415:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError415Example.json
      500:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError500Example.json
      501:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/getState/getStateResponseError501Example.json

/cachestate/{MSISDN}/{State}:
  uriParameters:
    MSISDN:
      description: Mobile Number key of the subscriber
      example: "spectre-freefb-639178217423"
    State:
      description: new State of the Mobile Number
      example: "1"

  post:
    is:
      - headerTrait
    description: Save State of the subscriber in the cache
    headers:
      correlationid:
        type: string
        description: Correlation ID being passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    body:
      application/json:
        type: saveStateRequest
        example: !include Examples/State Example/saveState/saveStateRequestExample.json
    responses:
      200:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateSuccessfulResponseExample.json
      400:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError400Example.json
      404:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError404Example.json 
      405:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError405Example.json
      406:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError406Example.json
      415:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError415Example.json
      500:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError500Example.json
      501:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/saveState/saveStateResponseError501Example.json

  put:
    is:
      - headerTrait
    description: Update State of the subscriber in the cache
    headers:
      correlationid:
        type: string
        description: Correlation ID being passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    body:
      application/json:
        type: updateStateRequest
        example: !include Examples/State Example/updateState/updateStateRequestExample.json
    responses:
      200:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateSuccessfulResponseExample.json
      400:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError400Example.json
      404:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError404Example.json 
      405:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError405Example.json
      406:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError406Example.json
      415:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError415Example.json
      500:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError500Example.json
      501:
        body:
          application/json:
            type: genericResponse
            example: !include Examples/State Example/updateState/updateStateResponseError501Example.json       